format PE GUI 4.0
entry start
include 'win32a.inc'
section '.data' data readable writeable
hInstance	dd ?   ;
nIcon		dd ?   ;
node		NOTIFYICONDATA ;
section '.code' code readable executable
  start:
	invoke	GetModuleHandle,0
	mov	[hInstance],eax
	invoke	DialogBoxParam,eax,37,HWND_DESKTOP,DialogProc,0
	invoke	ExitProcess,0
proc DialogProc hwnddlg,msg,wparam,lparam
	push	ebx esi edi
	cmp	[msg],WM_INITDIALOG
	je	.wminitdialog
	cmp	[msg],WM_COMMAND
	je	.wmcommand
	cmp	[msg],WM_CLOSE
	je	.wmclose
	cmp	[msg],WM_LBUTTONDOWN
	je	.drag_window
	cmp	[msg],WM_TIMER
	je	.animate
	xor	eax,eax
	jmp	.finish
  .drag_window:
	invoke	ReleaseCapture
	invoke	SendMessage,[hwnddlg],WM_SYSCOMMAND,61458,0
	jmp	.processed
  .wminitdialog:
	invoke	LoadIcon,[hInstance],1
	invoke	SendMessage,[hwnddlg],WM_SETICON,ICON_BIG,eax
	invoke	SetTimer,[hwnddlg],1,100,NULL
	mov	[nIcon],1
	mov	[node.cbSize],sizeof.NOTIFYICONDATA
	mov	eax,[hwnddlg]
	mov	[node.hWnd],eax
	mov	[node.uID],NULL
	mov	[node.uFlags],NIF_ICON
	mov	[node.uCallbackMessage],NULL
	invoke	LoadIcon, [hInstance], 1
	mov	[node.hIcon],eax
	invoke	Shell_NotifyIcon, NIM_ADD,node
	invoke	SetTimer,[hwnddlg],1,100,NULL
	mov	[nIcon],1
	jmp	.processed
  .animate:
	inc	[nIcon]
	cmp	[nIcon],25
	jbe	@f
	mov	[nIcon],1
  @@:
	invoke	LoadIcon,[hInstance],[nIcon]
	invoke	SendMessage,[hwnddlg],WM_SETICON,ICON_BIG,eax
	inc	[nIcon]
	cmp	[nIcon],25
	jbe	@f
	mov	[nIcon],1
  @@:
	invoke	LoadIcon, [hInstance], [nIcon]
	mov	[node.hIcon],eax
	invoke	Shell_NotifyIcon,NIM_MODIFY,node
	jmp	.processed
  .wmcommand:
	cmp	[wparam],BN_CLICKED shl 16 + IDCANCEL
	je	.wmclose
	jmp	.processed
  .wmclose:
	invoke	Shell_NotifyIcon,NIM_DELETE,node
	invoke	EndDialog,[hwnddlg],0
  .processed:
	mov	eax,1
  .finish:
	pop	edi esi ebx
	ret
endp
section '.idata' import data readable writeable
  library kernel32,'KERNEL32.DLL',\
	  user32,'USER32.DLL',\
	  shell32,'shell32.dll'
  include 'api\kernel32.inc'
  include 'api\user32.inc'
  include 'api\shell32.inc'
section '.rsrc' resource data readable
  directory RT_ICON,icons,\
	    RT_GROUP_ICON,group_icons,\
	    RT_DIALOG,dialogs
  resource group_icons,\
	   1,LANG_NEUTRAL,animate1,\
	   2,LANG_NEUTRAL,animate2,\
	   3,LANG_NEUTRAL,animate3,\
	   4,LANG_NEUTRAL,animate4,\
	   5,LANG_NEUTRAL,animate5,\
	   6,LANG_NEUTRAL,animate6,\
	   7,LANG_NEUTRAL,animate7,\
	   8,LANG_NEUTRAL,animate8,\
	   9,LANG_NEUTRAL,animate9,\
	   10,LANG_NEUTRAL,animate10,\
	   11,LANG_NEUTRAL,animate11,\
	   12,LANG_NEUTRAL,animate12,\
	   13,LANG_NEUTRAL,animate13,\
	   14,LANG_NEUTRAL,animate14,\
	   15,LANG_NEUTRAL,animate15,\
	   16,LANG_NEUTRAL,animate16,\
	   17,LANG_NEUTRAL,animate17,\
	   18,LANG_NEUTRAL,animate18,\
	   19,LANG_NEUTRAL,animate19,\
	   20,LANG_NEUTRAL,animate20,\
	   21,LANG_NEUTRAL,animate21,\
	   22,LANG_NEUTRAL,animate22,\
	   23,LANG_NEUTRAL,animate23,\
	   24,LANG_NEUTRAL,animate24,\
	   25,LANG_NEUTRAL,animate25
  resource icons,\
	   1,LANG_NEUTRAL,icon_data1,\
	   2,LANG_NEUTRAL,icon_data2,\
	   3,LANG_NEUTRAL,icon_data3,\
	   4,LANG_NEUTRAL,icon_data4,\
	   5,LANG_NEUTRAL,icon_data5,\
	   6,LANG_NEUTRAL,icon_data6,\
	   7,LANG_NEUTRAL,icon_data7,\
	   8,LANG_NEUTRAL,icon_data8,\
	   9,LANG_NEUTRAL,icon_data9,\
	   10,LANG_NEUTRAL,icon_data10,\
	   11,LANG_NEUTRAL,icon_data11,\
	   12,LANG_NEUTRAL,icon_data12,\
	   13,LANG_NEUTRAL,icon_data13,\
	   14,LANG_NEUTRAL,icon_data14,\
	   15,LANG_NEUTRAL,icon_data15,\
	   16,LANG_NEUTRAL,icon_data16,\
	   17,LANG_NEUTRAL,icon_data17,\
	   18,LANG_NEUTRAL,icon_data18,\
	   19,LANG_NEUTRAL,icon_data19,\
	   20,LANG_NEUTRAL,icon_data20,\
	   21,LANG_NEUTRAL,icon_data21,\
	   22,LANG_NEUTRAL,icon_data22,\
	   23,LANG_NEUTRAL,icon_data23,\
	   24,LANG_NEUTRAL,icon_data24,\
	   25,LANG_NEUTRAL,icon_data25
  resource dialogs,\
	   37,LANG_ENGLISH+SUBLANG_DEFAULT,demonstration
  icon animate1,\
	   icon_data1,'1.ico'
  icon animate2,\
	   icon_data2,'2.ico'
  icon animate3,\
	   icon_data3,'3.ico'
  icon animate4,\
	   icon_data4,'4.ico'
  icon animate5,\
	   icon_data5,'5.ico'
  icon animate6,\
	   icon_data6,'6.ico'
  icon animate7,\
	   icon_data7,'7.ico'
  icon animate8,\
	   icon_data8,'8.ico'
  icon animate9,\
	   icon_data9,'9.ico'
  icon animate10,\
	   icon_data10,'10.ico'
  icon animate11,\
	   icon_data11,'11.ico'
  icon animate12,\
	   icon_data12,'12.ico'
  icon animate13,\
	   icon_data13,'13.ico'
  icon animate14,\
	   icon_data14,'14.ico'
  icon animate15,\
	   icon_data15,'15.ico'
  icon animate16,\
	   icon_data16,'16.ico'
  icon animate17,\
	   icon_data17,'17.ico'
  icon animate18,\
	   icon_data18,'18.ico'
  icon animate19,\
	   icon_data19,'19.ico'
  icon animate20,\
	   icon_data20,'20.ico'
  icon animate21,\
	   icon_data21,'21.ico'
  icon animate22,\
	   icon_data22,'22.ico'
  icon animate23,\
	   icon_data23,'23.ico'
  icon animate24,\
	   icon_data24,'24.ico'
  icon animate25,\
	   icon_data25,'25.ico'
  dialog demonstration,'Window Animation Icon',0,0,190,55,WS_CAPTION+WS_SYSMENU+DS_CENTER+DS_SYSMODAL
    dialogitem 'BUTTON','',-1, 2, -1, 185, 35,WS_VISIBLE+BS_GROUPBOX
    dialogitem 'STATIC','KIT 18-a Yatsenko Mihail!',-1,6,15,177,13,WS_VISIBLE+ES_CENTER
    dialogitem 'BUTTON','Exit',IDCANCEL,135,37,50,15,WS_VISIBLE+WS_TABSTOP+BS_PUSHBUTTON
  enddialog